;TIP1204A.LSP:     BP_DIM.LSP    Dimension Variables    (c)1996, Bruce Peters
 
; defun dialog box
(defun bpd()
  (setq dcl_id (load_dialog "bp_dim.dcl"))
  (if (not (new_dialog "bp_dim" dcl_id))
    (exit)
  )

  ;Initialize tiles
  (set_tile "dimlfac" (rtos dimlfac 2 4))
  (set_tile "dimtp" (rtos dimtp 2 luprec))
  (set_tile "dimtm" (rtos dimtm 2 luprec))
  (set_tile "luprec" (rtos luprec 2 0))
  (set_tile "dimse1" (rtos dimse1 2 0))
  (set_tile "dimse2" (rtos dimse2 2 0))
  (set_tile "dimass" (rtos dimaso 2 0))
  (set_tile "dimpost" dimpost)

  ;set tolerance
  (if (and
      (= dimtol  0) (= dimlim 0)
    )
    (progn
      (setq toltest 1)
      (set_tile "tolnone" (rtos toltest 2 0))
    )
  )
  (set_tile "dimtol" (rtos dimtol 2 0))
  (set_tile "dimlim" (rtos dimlim 2 0))

  ;ACTION TILES
  ;
  (action_tile "dimse1" "(dims1 $value)")
  (action_tile "dimse2" "(dims2 $value)")
  (action_tile "tol_lim" "(tol $value)")
  (action_tile "dimlfac" "(dimlf $value)")
  (action_tile "dimtp" "(dmtp $value)")
  (action_tile "dimtm" "(dmtm $value)")
  (action_tile "luprec" "(lup $value)")
  (action_tile "chkcolor" "(col1 $value)")
  (action_tile "refcolor" "(col2 $value)")
  (action_tile "dimcmd" "(dcmd $value)")
  (action_tile "dimass" "(dimas1 $value)")
  (action_tile "dimpost" "(dimpt1 $value)")

  (start_dialog)
  (unload_dialog dcl_id)
)
; close dialog box

;*********************************************************
(defun C:DIMDIA()  
  (setq DIMSE1 (getvar "DIMSE1")
    DIMSE2 (getvar "DIMSE2")
    DIMTOL (getvar "DIMTOL")
    DIMLIM (getvar "DIMLIM")
    DIMLFAC (getvar "DIMLFAC")
    DIMTP (getvar "DIMTP")
    DIMTM (getvar "DIMTM")
    LUPREC (getvar "LUPREC")
    DIMAPOST (getvar "DIMAPOST")
    DIMCLRT (getvar "DIMCLRT")
    DIMCLRD (getvar "DIMCLRD")
    DIMASO (getvar "DIMASO")
    DIMPOST (getvar "DIMPOST")
  )
  (setvar "CMDECHO" 0)

  ;First extension line
  (defun dims1 (DIMSE1_VALUE)
    (setq DIMSE1 (atoi DIMSE1_VALUE))
    (setvar "DIMSE1" DIMSE1)
  )

  ;Second extension line
  (defun dims2 (DIMSE2_VALUE)
    (setq DIMSE2 (atoi DIMSE2_VALUE))
    (setvar "DIMSE2" DIMSE2)
  )

  ;Tolerance/limits
  (defun tol (tlv)
    (cond ((= tlv "tolnone") (progn (setvar "dimtol" 0)(setvar "dimlim" 0)))
      ((= tlv "dimtol") (progn (setvar "dimtol" 1)(setvar "dimlim" 0)))
      ((= tlv "dimlim") (progn (setvar "dimtol" 0)(setvar "dimlim" 1)))
    )
  )

  ;Dimlfac
  (defun dimlf (DLF)
    (setq DIMLFAC (distof DLF))
    (setvar "DIMLFAC" DIMLFAC)
  )

  ;Associative
  (defun dimas1 (DS1)
    (setq DIMASO (atoi DS1))
    (setvar "DIMASO" DIMASO)
  )

  ;Dimtp
  (defun dmtp (DTP)
    (setq DIMTP (distof DTP))
    (setvar "DIMTP" DIMTP)
  )

  ;Dimtm
  (defun dmtm (DTM)
    (setq DIMTM (distof DTM))
    (setvar "DIMTM" DIMTM)
  )  

  ;Luprec
  (defun lup (LP1)
    (setq LUPREC (atoi LP1))
    (setvar "LUPREC" LUPREC)
  ) 

  ;Dimpost
  (defun dimpt1 (DIM1AV)
    (if (/= DIM1AV  nil) (setq DIMPOST DIM1AV) (setq DIMPOST "."))
    (setvar "DIMPOST" DIMPOST) 
  )  ;close defun


  ;Dimension command
  (defun dcmd (DCCMD)
    (cond 
      ((= DCCMD "hor") (setq DIMCD 0))
      ((= DCCMD "vert") (setq DIMCD 1))
      ((= DCCMD "dia") (setq DIMCD 2))
      ((= DCCMD "rad") (setq DIMCD 3))
      ((= DCCMD "ang") (setq DIMCD 4))
      ((= DCCMD  "lea") (setq DIMCD 5))
      ((= DCCMD "upd") (setq DIMCD 6))
    )
  )

  (bpd)
  (cond 
    ((= DIMCD 0)(command "dim" "hor"))
    ((= DIMCD 1) (command "dim" "ver"))
    ((= DIMCD 2) (command "dim" "dia"))
    ((= DIMCD 3) (command "dim" "rad"))
    ((= DIMCD 4) (command "dim" "ang"))
    ((= DIMCD 5) (command "dim" "lea"))
    ((= DIMCD 6) (command "dim" "update"))
  )
  (setq DIMCD nil)
); end bp_dim.lsp
