;TIP1206C.LSP:      DDCHLTY.LSP       Change Linetype      (c)1996, Brian Mothershed
 
;;--------ROUTINE----------
(defun getltc (/ XX LTY)
  (setq LLIST '())
  (setq XX T)
  (while (setq LTY (tblnext "LTYPE" XX))
    (setq LLIST (append LLIST (list (cdr(assoc 2 LTY)))))
    (setq XX nil)
  );while
  (setq LLIST (append LLIST (list "BYBLOCK" "BYLAYER")))
  (if (<= (length LLIST) (getvar "maxsort"))
    (setq LLIST (acad_strlsort LLIST))     
  );if
);defun GETLTC
;;--------ROUTINE----------
(defun ltyli (VALN)
  (set_tile "error" "")
  (setq LNOM (nth (atoi VALN) LLIST))
  (set_tile "EDITLT" LNOM)
);defun
;;--------ROUTINE----------
(defun ltedit (VAL)
  (set_tile "error" "")
  (setq VAL (strcase VAL))
  (setq LNOM VAL)
  (new_dialog "new" dclid)
  (action_tile "accept" "(new_add)")
  (action_tile "cancel" "(res-lay)")
  (start_dialog)
);defun
;;---------ROUTINE ADD LAYER------------
(defun new_add ()
  (setq adnew "brian")
  (done_dialog 1)
)
(defun res-lay ()
  (setq LNOM VAL)
  (done_dialog 0)
)
;;--------ROUTINE----------
(defun siok ()
  (if (= (get_tile "error") "")
    (done_dialog 1)
  );if
);defun
;;---------MAIN PROGRAM------
(defun c:DDCHLTY (/ LLIST XX LTY VALN VAL DCLID)
  (setq xp_ver "1.00")  

  (setq xp_oer *error* 
  *error* xp_err)
  (setq xp_oce (getvar "cmdecho"))    ; save value of cmdecho
  (setvar "cmdecho" 0)                ; turn cmdecho off

  (princ (strcat "\nVersion " xp_ver ", (c) 1995 by Brian Mothershed "))
  ;;------------------------
  (setq A (SSGET))
  (if A (progn 
      (setq ADNEW nil) (setq CHLTY nil)
      (getltc)
      (setq DCLID (load_dialog "DDCHLTY.DCL"))
      (if (not (new_dialog "GETLTY" DCLID))
        (progn
          (alert "File DDCHLTY.DCL not found.")
          (EXIT)
        );progn
      );if
      (set_tile "LTYCOU" (getvar "celtype"))
      (setq LNOM (getvar "celtype"))              
      (start_list "LISTLT")
      (mapcar 'add_list LLIST)                   
      (end_list)
      ;   (set_tile "EDITLT" (getvar "celtype"))
      (action_tile "LISTLT" "(LTYLI $value)")
      (action_tile "EDITLT" "(LTEDIT $value)")
      (action_tile "accept" "(SIOK)")
      (action_tile "cancel" "(setq LNOM nil)(done_dialog 0)")
      (if (= (start_dialog) 1)                   
        (progn (set_tile "EDITLT" LNOM)
          (if (= ADNEW "brian")
          (command "linetype" "l" LNOM "" ""))
          (setq B LNOM)
          (if (/= B "BYLAYER") 
            (if (/= B "BYBLOCK")
              (if (= nil (TBLSEARCH "Ltype" B))
                (progn (alert "LineType Selected Does Not Exist!")
                  (setq CHLTY "bm")
                  (princ "\nProperties Unchanged")
                );progn
              );if
            );if 
          );if
          (if (= CHLTY nil)
          (command "chprop" A "" "lt" B ""))
        );progn
      );if 
    );progn
  );if
  (princ)
);end ddchlty.lsp
